[tor-commits] [tor/master] scripts/cocci: Add check_cocci_parse.sh and default exceptions

teor at torproject.org teor at torproject.org
Fri Oct 25 06:15:24 UTC 2019


commit 330717f01845a2fea45b79d914161d6a2a897815
Author: teor <teor at torproject.org>
Date:   Wed Oct 23 15:40:09 2019 +1000

    scripts/cocci: Add check_cocci_parse.sh and default exceptions
    
    Add check_cocci_parse.sh, which is a thin wrapper around
    try_parse.sh. Add a default exceptions file, and use it in
    check_cocci_parse.sh.
    
    Part of 31919.
---
 scripts/coccinelle/check_cocci_parse.sh | 36 +++++++++++++++++++++++++++++++++
 scripts/coccinelle/exceptions.txt       | 24 ++++++++++++++++++++++
 2 files changed, 60 insertions(+)

diff --git a/scripts/coccinelle/check_cocci_parse.sh b/scripts/coccinelle/check_cocci_parse.sh
new file mode 100755
index 000000000..a422a99da
--- /dev/null
+++ b/scripts/coccinelle/check_cocci_parse.sh
@@ -0,0 +1,36 @@
+#!/bin/sh
+
+# If we have coccinelle installed, run try_parse.sh on every filename passed
+# as an argument. Uses the default coccinelle exceptions file, if
+# $TOR_COCCI_EXCEPTIONS_FILE is not set.
+#
+# Use TOR_COCCI_EXCEPTIONS_FILE=/dev/null check_cocci_parse.sh to disable
+# the default exception file.
+#
+# If spatch is not installed, remind the user to install it, but exit with
+# a success error status.
+
+scripts_cocci="$(dirname "$0")"
+top="$scripts_cocci/../.."
+try_parse="$scripts_cocci/try_parse.sh"
+
+exitcode=0
+
+export TOR_COCCI_EXCEPTIONS_FILE="${TOR_COCCI_EXCEPTIONS_FILE:-$scripts_cocci/exceptions.txt}"
+
+if ! command -v spatch; then
+    echo "Install coccinelle's spatch to check cocci C parsing!"
+    exit "$exitcode"
+fi
+
+"$try_parse" "$@"
+exitcode=$?
+
+if test "$exitcode" != 0 ; then
+    echo "Please fix these cocci parsing errors in the above files"
+    echo "Set VERBOSE=1 for more details"
+    echo "Try running test-operator-cleanup or 'make autostyle-operators'"
+    echo "As a last resort, you can modify scripts/coccinelle/exceptions.txt"
+fi
+
+exit "$exitcode"
diff --git a/scripts/coccinelle/exceptions.txt b/scripts/coccinelle/exceptions.txt
new file mode 100644
index 000000000..473f4b22c
--- /dev/null
+++ b/scripts/coccinelle/exceptions.txt
@@ -0,0 +1,24 @@
+# A list of exception patterns for check_cocci_parse.sh
+# Passed to 'grep -f'
+src/lib/cc/compat_compiler.h
+src/lib/container/handles.h
+src/lib/container/map.c
+src/lib/container/map.h
+src/lib/container/order.c
+src/lib/crypt_ops/crypto_rand.c
+src/lib/fs/files.h
+src/lib/log/util_bug.c
+src/lib/pubsub/pubsub_macros.h
+src/lib/smartlist_core/smartlist_foreach.h
+src/lib/testsupport/testsupport.h
+src/lib/tls/tortls.h
+src/lib/tls/tortls_openssl.c
+src/lib/tls/x509.h
+src/lib/version/version.c
+src/core/mainloop/connection.c
+src/core/or/reasons.c
+src/feature/dirclient/dirclient.c
+src/feature/nodelist/networkstatus.c
+src/test/test_address.c
+src/test/test_hs_cache.c
+src/test/test_hs_descriptor.c





More information about the tor-commits mailing list